"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const yargs_1 = __importDefault(require("yargs"));
const metadata = {};
function Option(options) {
    return (target, propertyKey) => {
        metadata[propertyKey] = options;
    };
}
exports.Option = Option;
function Cli(constructor) {
    return class extends constructor {
        constructor(...rest) {
            super();
            for (let propertyKey in metadata) {
                metadata[propertyKey].default = this[propertyKey];
            }
            const args = yargs_1.default.options(metadata).argv;
            for (let propertyKey in metadata) {
                if (metadata[propertyKey])
                    this[propertyKey] = args[propertyKey];
            }
        }
    };
}
exports.Cli = Cli;
